﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Input;

namespace XamComboEditorBehavior
{
    public class VM : INotifyPropertyChanged
    {
        private ObservableCollection<Person> people;
        private ObservableCollection<Person> selectedPeople;
        private Person selectedPerson;
        private ICommand command1;

        public ObservableCollection<Person> People
        {
            get
            {
                return people;
            }
            set
            {
                people = value;
                this.RaisePropertyChanged("People");
            }
        }

        public ObservableCollection<Person> SelectedPeople
        {
            get
            {
                return selectedPeople;
            }
            set
            {
                selectedPeople = value;
                this.RaisePropertyChanged("People");
            }
        }

        public Person SelectedPerson
        {
            get
            {
                return selectedPerson;
            }
            set
            {
                selectedPerson = value;
                this.RaisePropertyChanged("SelectedPerson");
            }
        }

        public ICommand Command1
        {
            get
            {
                return this.command1;
            }
        }


        public VM()
        {
            People = new ObservableCollection<Person>();
            SelectedPeople = new ObservableCollection<Person>();
            SelectedPerson = new Person();

            People.Add(new Person() { Age = 60, Name = "John" });
            People.Add(new Person() { Age = 12, Name = "Brenda" });
            People.Add(new Person() { Age = 10, Name = "Tom" });
            this.command1 = new DelegateCommand(this.CommandAction);
        }

        private void CommandAction(object p)
        {
            SelectedPeople.Add(People.LastOrDefault());
        }


        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
